SystemOrganization addCategory: #'IRDA2013-sorting2-Tests'!

TestCase subclass: #S2BubblesorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 7/14/2013 23:56:11.177'!
testComplexity
|sorter |
	sorter := S2BubbleSorter newWithElements: #(1 2 3 4 5 6 7 8) asOrderedCollection.
	sorter sort.
	self assert: sorter list complexity equals: 28.! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 7/14/2013 19:56:21.271'!
testKeepFocusing
| list listPartSorter |
	list := S2List newWithElements: #( 3 4 5 6 7 8).
	listPartSorter := S2BubblesortSublistSorter newWithList: list.
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	self assert: (listPartSorter keepFocusing).
	list firstSortedIndex: 4.
	list secondFocusedIndex: 4.
	self assert: (listPartSorter keepFocusing) not.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 7/4/2013 11:54:03.372'!
testResume
|list sorter sortedList|
"Todo: Test that it is actually resuming."
list := S2List newWithElements: #(5 4 3 6 7 8).
	list leftBoundIndex: 1.
	list rightBoundIndex: 3.
	list sortedIndices: #(4 5 6) asSortedCollection.
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	sorter := S2BubbleSorter newWithList: list.
	sortedList := #(3 4 5 6 7 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:39:56.246'!
testSort
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:40:49.605'!
testSortAllEqual
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2 2 2) asOrderedCollection.
	sortedList := #(2 2 2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:41:06.671'!
testSortEmpty
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #() asOrderedCollection.
	sortedList := #() asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:41:27.804'!
testSortOne
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2) asOrderedCollection.
	sortedList := #(2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

TestCase subclass: #S2ListMorphTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2ListMorphTests methodsFor: 'as yet unclassified' stamp: 'AT 7/4/2013 13:54:28.869'!
testHandleElements

	| list morph elements sorter |
	morph := S2ListMorph new openInWorld.
	list := S2List new.
	morph connectTo: list.	
	elements := (1 to: 4) asOrderedCollection shuffled.
	list setupList: elements.

	sorter := S2QuickSorter new.
	sorter setupWithList: list.
	sorter sort.
	morph delete.
	self assert: false.! !

TestCase subclass: #S2ListTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 11:52:19.378'!
testActivatePartition
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitionIndices: #(#(1 2) #(3 4)) asOrderedCollection.
	list activePartitions: #(1) asOrderedCollection.
	list activatePartition: 2.
	self assert: (list activePartitions) equals: #(1 2) asOrderedCollection.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:57:59.3'!
testAddElementAsSorted
	| expected list |
	list := S2List new.
	list sortedIndices: #(3 2) asSortedCollection.
	expected := #(4 3 2) asSortedCollection.
	list addIndexAsSorted: 4.
	self assert: (list sortedIndices) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 18:14:18.644'!
testAddElementIndexToTmpList
	| list |
	list := S2List new.
	list setupList: #(7 4 2 0) asOrderedCollection.
	list setupMultiListInterface.
	list splitAfter: 2.
	list splitAfter: 4.
	list addElementIndexToTmpList: 3.
	self assert: (list tmpList) equals: #(2) asOrderedCollection.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 7/15/2013 11:21:04.047'!
testCompare
	| list |
	list := S2List newWithElements: #(1 2 2).
	self assert: (list compareElementAt: 1 withElementAt: 2) equals: (0-1).
	self assert: (list compareElementAt: 2 withElementAt: 1) equals: (1).
	self assert: (list compareElementAt: 2 withElementAt: 3) equals: (0)! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 11:52:24.42'!
testDeactivatePartition
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitionIndices: #(#(1 2) #(3 4)) asOrderedCollection.
	list activePartitions: #(1) asOrderedCollection.
	list deactivatePartition: 1.
	self assert: (list activePartitions) equals: #() asOrderedCollection.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 7/10/2013 01:47:17.809'!
testEquals
|a b|
	a := S2List newWithElements: #(4 2 nil 5 3 6).
	a sortedIndices: #(3 5).
	a leftBoundIndex: 2.
	a rightBoundIndex: 5.
	a firstFocusedIndex: 3. 
	a secondFocusedIndex: 4.
	a pivotIndex: 7.
	a partitionIndices: #() asOrderedCollection.
	a activePartitions: #(2 3) asOrderedCollection.
	a tmpList: #(3) asOrderedCollection.
	a isSorted: false.
	
	b := a deepCopy.
	
 	self assert: (a equals: b). 
	
	b partitionIndices add: #(2 3 4) asOrderedCollection.
	
	self assert: (a equals: b) not. ! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 14:39:54.746'!
testFirstSortedIndex
	| list |
	list := S2List newWithElements: #(4 5 6 7 8).
	self assert: (list firstSortedIndex) equals: 6.
	list firstSortedIndex: list elements size.
	self assert: (list firstSortedIndex) equals: (list elements size).! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:30:22.982'!
testInsertPivotAt1
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 7.
	expected := #(3 7 1 2 0 8 0 2) asOrderedCollection.
	list insertPivotAt: 3.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:21:25.101'!
testInsertPivotAt2
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 8.
	expected := #(2 3 7 2 0 8 0 1) asOrderedCollection.
	list insertPivotAt: 1.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:28:50.913'!
testInsertPivotAt3
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 4.
	expected := #(3 7 2 8 0 0 1 2) asOrderedCollection.
	list insertPivotAt: 7.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 19:25:35.429'!
testInsertPivotAt4
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 4.
	expected := #(3 7 2 0 8 0 1 2) asOrderedCollection.
	list insertPivotAt: 4.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 7/15/2013 02:09:19.948'!
testMergeBackTmpList
	| list expected |
	list := S2List new.
	list setupList: #(nil nil 2 0) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #(1) asOrderedCollection.
	list partitionIndices add: #(2) asOrderedCollection.
	list partitionIndices add: #(3)asOrderedCollection.
	list partitionIndices add: #(4) asOrderedCollection.
	list activePartitions: #(1 2) asOrderedCollection.
	list tmpList: #(7 4) asOrderedCollection.
	list mergeBackTmpList.
	expected := #() asOrderedCollection.
	expected add: #(1 2) asOrderedCollection.
	expected add: #(3) asOrderedCollection.
	expected add: #(4) asOrderedCollection.
	self assert: (list elements) equals: #(7 4 2 0) asOrderedCollection.
	self assert: (list partitionIndices) equals: expected.
	self assert: (list tmpList) equals: #() asOrderedCollection. ! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 7/15/2013 02:10:12.297'!
testMergeBackTmpList2
	| list expected |
	list := S2List new.
	list setupList: #(nil nil nil nil 2 0) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #(1 2) asOrderedCollection.
	list partitionIndices add: #(3 4) asOrderedCollection.
	list partitionIndices add: #(5)asOrderedCollection.
	list partitionIndices add: #(6) asOrderedCollection.
	list activePartitions: #(1 2) asOrderedCollection.
	list tmpList: #(7 4 4 1) asOrderedCollection.
	list mergeBackTmpList.
	expected := #() asOrderedCollection.
	expected add: #(1 2 3 4) asOrderedCollection.
	expected add: #(5) asOrderedCollection.
	expected add: #(6) asOrderedCollection.
	self assert: (list elements) equals: #(7 4 4 1 2 0) asOrderedCollection.
	self assert: (list partitionIndices) equals: expected.
	self assert: (list tmpList) equals: #() asOrderedCollection. ! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 12:15:43.27'!
testPartitions
	| list expected |
	list := S2List new.
	list setupList: #(7 4 2 0) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #(1 2) asOrderedCollection.
	list partitionIndices add: #(3 4) asOrderedCollection.
	expected := #() asOrderedCollection.
	expected add: #(7 4) asOrderedCollection.
	expected add: #(2 0) asOrderedCollection.
	self assert: (list partitions) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 12:03:09.411'!
testSplit1
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitionIndices: #(#(1 2) #(3 4)) asOrderedCollection.
	list splitAfter: 1.
	self assert: (list partitionIndices) equals: #(#(1) #(2) #(3 4)) asOrderedCollection .! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 12:03:11.786'!
testSplit2
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitionIndices: #(#(1) #(2 3 4)) asOrderedCollection.
	list splitAfter: 3.
	self assert: (list partitionIndices) equals: (#(#(1) #(2 3) #(4)) asOrderedCollection).! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 12:03:14.86'!
testSplitAll
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitionIndices: #(#(1 2 3 4)) asOrderedCollection.
	list splitAll.
	self assert: (list partitionIndices) equals: (#(#(1) #(2) #(3) #(4)) asOrderedCollection).! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 14:30:09.023'!
testSwapFocusedElements
	| list |
	list := S2List newWithElements: #(3 7 2 0 8 0 1 2).
	list firstFocusedIndex: 3.
	list secondFocusedIndex: 6.
	list swapFocusedElements.
	self assert: (list elements) equals: (#(3 7 0 0 8 2 1 2) asOrderedCollection)! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:52:43.334'!
testSwitchElments
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	expected := #(3 7 8 0 2 0 1 2) asOrderedCollection.
	list switchElementAt: 3 withElementAt: 5.
	self assert: (list elements) equals: expected.! !

TestCase subclass: #S2MergesorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/25/2013 16:47:10.751'!
testAppendListRestsToTmpList
	| list sublistSorter |
	list := S2List new.
	list setupList: #(nil nil nil 2 0 1 5) asOrderedCollection.
	list partitionIndices: #() asOrderedCollection.
	list partitionIndices add: #() asOrderedCollection.
	list partitionIndices add: #(4) asOrderedCollection.
	list partitionIndices add: #(5 6) asOrderedCollection.
	list partitionIndices add: #(7) asOrderedCollection.
	list activePartitions: #(1 2) asOrderedCollection.
	list tmpList: #(7 4 9) asOrderedCollection.
	sublistSorter := S2MergesortSublistSorter newWithList: list.
	sublistSorter appendListRestsToTmpList.
	self assert: (list elements) equals: #(nil nil nil nil 0 1 5) asOrderedCollection.
	self assert: (list tmpList) equals: #(7 4 9 2) asOrderedCollection.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 17:50:33.58'!
testFindSublist
	| list sublistFinder |
	list := S2List new.
	list setupList: #(7 4 9 2 0) asOrderedCollection.
	list setupMultiListInterface.
	list splitAfter: 2.
	list splitAfter: 4.
	sublistFinder := S2MergesortSublistFinder newWithList: list.
	sublistFinder findSublist.
	self assert: (list activePartitions) equals: #(1 2) asOrderedCollection.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 7/14/2013 19:56:49.137'!
testKeepFocusing1
| list listPartSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list partitionIndices: #(#(1 2) #(3 4 5)) asOrderedCollection.
	list activePartitions: #(1 2) asOrderedCollection.
	listPartSorter := S2MergesortSublistSorter newWithList: list.
	self assert: listPartSorter keepFocusing! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 7/15/2013 02:11:16.541'!
testKeepFocusing2
| list listPartSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list partitionIndices: #(#(1 2) #(3 4) #(5)) asOrderedCollection.
	list activePartitions: #(1 2) asOrderedCollection.
	listPartSorter := S2MergesortSublistSorter newWithList: list.
	self assert: listPartSorter keepFocusing! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 15:10:33.682'!
testSort
|sorter sortedList|
	sorter := S2MergeSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 7/7/2013 20:14:54.499'!
testSort1
|sorter sortedList|
	sorter := S2MergeSorter newWithElements: #(4 3 5 6 7 1 8 2).
	sortedList := #(1 2 3 4 5 6 7 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 22:16:48.637'!
testSortEmpty
|sorter sortedList|
	sorter := S2MergeSorter newWithElements: #().
	sortedList := #() asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/24/2013 22:17:41.279'!
testSortOdd
|sorter sortedList|
	sorter := S2MergeSorter newWithElements: #(4 4 4 4 4).
	sortedList := #(4 4 4 4 4) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 7/7/2013 20:37:48.446'!
testSortRandom
|sorter sortedList|
	sorter := S2MergeSorter newWithElements: (1 to: 8) asOrderedCollection.
	sortedList := #(1 2 3 4 5 6 7 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2MergesorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 17:52:12.729'!
testSublistOdd
	| list sublistFinder |
	list := S2List new.
	list setupList: #(7 4 9 2 0 1 5) asOrderedCollection.
	list setupMultiListInterface.
	list splitAfter: 4.
	list splitAfter: 6.
	sublistFinder := S2MergesortSublistFinder newWithList: list.
	sublistFinder findSublist.
	self assert: (list activePartitions) equals: #(2 3) asOrderedCollection.! !

TestCase subclass: #S2OOPQuicksorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2OOPQuicksorterTests methodsFor: 'as yet unclassified' stamp: 'AT 6/27/2013 17:36:13.841'!
testSort
|sorter sortedList|
	sorter := S2OOPQuickSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2OOPQuicksorterTests methodsFor: 'as yet unclassified' stamp: 'AT 7/14/2013 19:31:44.308'!
testSortedElements
|sorter|
	sorter := S2OOPQuickSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sorter sort.
	self assert: (sorter list sortedIndices) equals: (1 to: 8) asSortedCollection.! !

TestCase subclass: #S2QuicksorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksorterTests methodsFor: 'list part sorting' stamp: 'AT 7/1/2013 12:26:32.698'!
testBeforeSortSublist
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4).
	list sortedIndices: #(2) asSortedCollection.
	list leftBoundIndex: 1.
	list rightBoundIndex: 1.
	partSorter := S2QuicksortSublistSorter newWithList: list.
	partSorter beforeSortSublist.
	self assert: (list firstFocusedIndex) equals: 1.
	self assert: (list secondFocusedIndex) equals: 1.
	self assert: (list pivotIndex) equals: 1.! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/25/2013 15:43:51.131'!
testFindSublist1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(3) asSortedCollection.
	finder := S2QuicksortSublistFinder newWithList: list.
	finder findSublist.
	self assert: (list leftBoundIndex) equals: 1.
	self assert: (list rightBoundIndex) equals: 2.! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/25/2013 15:24:07.302'!
testFindSublist2
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(2) asSortedCollection.
	finder := S2QuicksortSublistFinder newWithList: list.
	finder findSublist.
	self assert: (list leftBoundIndex) equals: 1.
	self assert: (list rightBoundIndex) equals: 1.! !

!S2QuicksorterTests methodsFor: 'iterating' stamp: 'AT 7/14/2013 19:57:17.626'!
testKeepFocusing1
| list listPartSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 5.
	listPartSorter := S2QuicksortSublistSorter newWithList: list.
	self assert: listPartSorter keepFocusing! !

!S2QuicksorterTests methodsFor: 'iterating' stamp: 'AT 7/14/2013 19:57:33.994'!
testKeepFocusing2
| list listPartSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 3.
	list secondFocusedIndex: 3.
	listPartSorter := S2QuicksortSublistSorter newWithList: list.
	self assert: listPartSorter keepFocusing not.! !

!S2QuicksorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/25/2013 15:48:59.4'!
testShouldUpdateElements
|evaluator list|
	list := S2List new.
	list setupList: #(3 1 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator shouldUpdateElements.
	! !

!S2QuicksorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/25/2013 15:49:21.689'!
testShouldUpdateElements2
|evaluator list|
	list := S2List new.
	list setupList: #(1 2 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator shouldUpdateElements not.
	! !

!S2QuicksorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/25/2013 15:49:25.43'!
testShouldUpdateElements3
|evaluator list|
	list := S2List new.
	list setupList: #(4 5 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator shouldUpdateElements not.
	! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 16:53:03.894'!
testSort
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:42:37.514'!
testSortAllEqual
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2 2 2 2).
	sortedList := #(2 2 2 2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:42:06.339'!
testSortEmpty
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #().
	sortedList := #() asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:42:18.016'!
testSortOne
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2).
	sortedList := #(2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/25/2013 15:50:46.987'!
testUpdateElements
|evaluator list|
	list := S2List new.
	list setupList: #(4 2 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	evaluator updateElements.
	self assert: (list elements) equals: #(2 4 3) asOrderedCollection.
	! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/25/2013 16:07:24.438'!
testUpdateFocusedIndices
| list focusedIndexFinder |
	list := S2List newWithElements: #(4 5 8 7 6 9 6).
	focusedIndexFinder := S2QuicksortFocusedIndicesFinder newWithList: list.
	list pivotIndex: 7.
	list firstFocusedIndex: 2.
	list secondFocusedIndex: 6.
	focusedIndexFinder updateFocusedIndices.
	self assert: (list firstFocusedIndex) equals: 3.
	self assert: (list secondFocusedIndex) equals: 6.
	focusedIndexFinder updateFocusedIndices.
	self assert: (list firstFocusedIndex) equals: 3.
	self assert: (list secondFocusedIndex) equals: 5.! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/25/2013 16:10:36.955'!
testUpdateFocusedIndices2
| list focusedIndexFinder |
	list := S2List newWithElements: #(2 5 8 2 6 4 8 2).
	focusedIndexFinder := S2QuicksortFocusedIndicesFinder newWithList: list.
	list pivotIndex: 8.
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 4.
	focusedIndexFinder updateFocusedIndices.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 4.! !

!S2QuicksorterTests methodsFor: 'list part sorting' stamp: 'AT 6/24/2013 11:43:35.661'!
testUpdatePivotPosition
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 3.
	list pivotIndex: 5.
	partSorter := S2QuicksortSublistSorter newWithList: list.
	partSorter updatePivotPosition.
	self assert: (list elements) equals: #(2 8 2 4 6) asOrderedCollection.! !

!S2QuicksorterTests methodsFor: 'list part sorting' stamp: 'AT 6/24/2013 11:43:38.67'!
testUpdateSortedIndices
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list sortedIndices: #() asSortedCollection.
	list pivotIndex: 5.
	partSorter := S2QuicksortSublistSorter newWithList: list.
	partSorter updateSortedIndices.
	self assert: (list sortedIndices) equals: (#(5) asSortedCollection).! !
